Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class Aggregate

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.Aggregate

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public class Aggregate

extends SystemFunction

This class implements the sum(), avg(), count() functions,

See Also:
  Serialized Form

Field Summary
`static int` | `AVG`
`static int` | `COUNT`
`static int` | `SUM`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Aggregate()`

Method Summary
`static AtomicValue` | `average(SequenceIterator iter, XPathContext context, SourceLocator location)` Calculate average
`void` | `checkArguments(StaticContext env)` Static analysis: prevent sorting of the argument
`int` | `computeCardinality()` Determine the cardinality of the function.
`static int` | `count(SequenceIterator iter)` Get the number of items in a sequence identified by a SequenceIterator
`Item` | `evaluateItem(XPathContext context)` Evaluate the function
`ItemType` | `getItemType(TypeHierarchy th)` Determine the item type of the value returned by the function
`static boolean` | `isCountFunction(Expression exp)` Determine whether a given expression is a call to the count() function
`static AtomicValue` | `total(SequenceIterator iter, XPathContext context, SourceLocator location)` Calculate the total of a sequence.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`computeSpecialProperties, display, getDetails, getErrorCodeForTypeErrors, main, makeSystemFunction, optimize, setDetails`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`getArguments, getDisplayName, getFunctionNameCode, getNumberOfArguments, iterateSubExpressions, preEvaluate, promote, replaceSubExpression, setArguments, setFunctionNameCode, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### SUM

    public static final int SUM

See Also:
  Constant Field Values

### AVG

    public static final int AVG

See Also:
  Constant Field Values

### COUNT

    public static final int COUNT

See Also:
  Constant Field Values

Constructor Detail

### Aggregate

    public Aggregate()

Method Detail

### checkArguments

    public void checkArguments(StaticContext env)
                        throws XPathException

  Static analysis: prevent sorting of the argument

  Overrides:
    `checkArguments` in class `SystemFunction`
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the item type of the value returned by the function

  Overrides:
    `getItemType` in class `SystemFunction`
  Parameters:
    `th` -
  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known at compile time)

### computeCardinality

    public int computeCardinality()

  Determine the cardinality of the function.

  Overrides:
    `computeCardinality` in class `SystemFunction`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the function

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### total

    public static AtomicValue total(SequenceIterator iter,
                                    XPathContext context,
                                    SourceLocator location)
                             throws XPathException

  Calculate the total of a sequence.

  Returns:
    the total, according to the rules of the XPath sum() function, but returning null if the sequence is empty. (It's then up to the caller to decide what the correct result is for an empty sequence.
  Throws:
    `XPathException`

### average

    public static AtomicValue average(SequenceIterator iter,
                                      XPathContext context,
                                      SourceLocator location)
                               throws XPathException

  Calculate average

  Throws:
    `XPathException`

### count

    public static int count(SequenceIterator iter)
                     throws XPathException

  Get the number of items in a sequence identified by a SequenceIterator

  Parameters:
    `iter` - The SequenceIterator. This method moves the current position of the supplied iterator; if this isn't safe, make a copy of the iterator first by calling getAnother(). The supplied iterator must be positioned before the first item (there must have been no call on next()).
  Returns:
    the number of items in the underlying sequence
  Throws:
    `XPathException` - if a failure occurs reading the input sequence

### isCountFunction

    public static boolean isCountFunction(Expression exp)

  Determine whether a given expression is a call to the count() function

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.